
if { $::tcl_platform(platform) == "windows"} {
    bind .gid <Control-x><Control-l> {
	set err [catch {
	    source {c:/Users/ramsan/barres/rambshell.gid/scripts/Reports.tcl}
	} errstring]
	if { !$err } {
	    WarnWin "Reports code reload"
	} else {
	    WarnWin "Reports code reload error ($err--$::errorInfo)"
	}
	
    }
}

namespace eval RamReports {
    variable images
    variable data
}
proc RamReports::Init {} {
    variable data

    if { [info exists data(Constraints)] } { return }

    set data(Constraints) 1
    set data(Connections) 1
    set data(Properties) 1
    set data(Loads) 1
    set data(what_loadcase) all
    set data(entype) Lines
    set data(line) 1
    set data(entities) sel
    set data(onlywithdata) 0

    set data(XComp) 0
    set data(YComp) 0
    set data(ZComp) 0
    set data(MComp) 1
    # for tensor results, this is XX
    set data(Mat0Comp) 1
    set data(gauss) absmax
    set data(enposttype) Elements
    #set data(onlywithdata) 0

}

proc RamReports::CreatePre { {w .gid.reports } } {
    variable images
    variable data

    CreateImages
    Init

    if { [info procs ::InitWindow] != "" } {
	InitWindow $w "Reports" PreRamReportsWindowGeom "" "" 1

    } else {
	catch { destroy $w }
	toplevel $w
	wm title $w "Reports"
    }

    g_TitleFrame $w.f1 -text "report data" -grid 0
    set f1 [$w.f1 getframe]

    g_checkbutton $f1.cb1 -text "Constraints" -variable RamReports::data(Constraints) -grid "0 w" 
    g_checkbutton $f1.cb2 -text "Connections" -variable RamReports::data(Connections) -grid "0 w" 
    g_checkbutton $f1.cb3 -text "Properties"  -variable RamReports::data(Properties)  -grid "0 w" 
    g_checkbutton $f1.cb4 -text "Loads" -variable RamReports::data(Loads) -grid "0 w" 
    g_radiobutton $f1.cb5 -text "Current loadcase"  -grid "0 w px10" -variable \
	RamReports::data(what_loadcase) -value current
    g_radiobutton $f1.cb6 -text "All loadcases"  -grid "0 w px10" -variable \
	RamReports::data(what_loadcase) -value all

    set comm [list if {!$RamReports::data(Loads)} \
		  "$f1.cb5 conf -state disabled ; $f1.cb6 conf -state disabled" else \
		  "$f1.cb5 conf -state normal ; $f1.cb6 conf -state normal"]

    trace var RamReports::data(Loads) w "$comm ;#"
    bind $f1.cb4 <Destroy> [list trace vdelete RamReports::data(Loads) w "$comm ;#"]

    g_checkbutton $f1.cb8 -text "Only entities with data" -variable RamReports::data(onlywithdata)\
	-grid "0 w" 


    supergrid::go $f1
    
    g_TitleFrame $w.f2 -text "included entities" -grid 0
    set f2 [$w.f2 getframe]

    g_frame $f2.but -grid 0
    set ic 0
    foreach i "point line surface volume" {
	g_radiobutton $f2.but.cb$i -image $images($i) -indicatoron 0 -variable \
	    RamReports::data(entype) -value [string totitle $i]s -grid "$ic px2"
	incr ic
    }
    g_radiobutton $f2.rb1 -text "All entities" -variable RamReports::data(entities) -value all \
	-grid 0
    g_radiobutton $f2.rb2 -text "Selected entities" -variable RamReports::data(entities) -value sel \
	-grid 1

    supergrid::go $f2

    g_frame $w.buts -bg [CCColorActivo [$f2 cget -bg]] -grid "0 ew"

    g_button $w.buts.b1 -text OK -und 0 -width 8 -grid "0 px3 e" \
	-command "set RamReports::data(action) ok"
    g_button $w.buts.b2 -text Cancel -und 0 -width 8 -grid "1 px3 py3 w" -command \
	"set RamReports::data(action) cancel"

    supergrid::go $w
    grid columnconf $w.buts "0 1" -weight 1
    grid columnconf $w.buts "2" -weight 0

    bind $w <Escape> "tkButtonInvoke $w.buts.b2"
    bind $w.buts.b2 <Return> "tkButtonInvoke $w.buts.b2"
    bind $w <Return> "tkButtonInvoke $w.buts.b1"
    bind $w <Alt-o> "tkButtonInvoke $w.buts.b1"
    bind $w <Alt-c> "tkButtonInvoke $w.buts.b2"
    focus $w.buts.b1
    wm protocol $w WM_DELETE_WINDOW "tkButtonInvoke $w.buts.b2"

    while 1 {
	vwait RamReports::data(action)
	
	if { $RamReports::data(action) == "cancel" } {
	    destroy $w
	    return
	}
	if { $RamReports::data(entities) == "sel" } {
	    .central.s process SelectEntities $data(entype)
	    set comm "RamReports::ReportPre ;#"
	    trace var ::GidPriv(selection) w $comm
	    FinishButton $w $w.buts \
		[_ Press 'Finish' when selection\nis finished] \
		"" disableall
	} else {
	    RamReports::ReportPre
	}
    }
}

proc RamReports::ListboxMoveDel { l1 l2 what } {
    variable data

    switch $what {
	move {
	    foreach i [$l1 curselection] {
		set res [$l1 get $i]
		if { [lsearch $data(selected_results) $res] == -1 } {
		    lappend data(selected_results) $res
		}
	    }
	}
	delete {
	    set todel ""
	    foreach i [$l2 curselection] {
		lappend todel [$l2 get $i]
	    }
	    foreach res $todel {
		set ipos [lsearch $data(selected_results) $res]
		set data(selected_results) [lreplace $data(selected_results) $ipos $ipos]
	    }
	}
    }
}

proc RamReports::FillListBoxes {} {
    variable data

    set data(current_results) ""
    if { $data(what_loadcase) == "current" } {
	set curr [.central.s info postprocess get cur_analisis]
	foreach i [.central.s info postprocess get results_list Contour_Fill $curr 1] {
	    regsub {[(][^\)]*[)]$} $i {} i
	    regsub -all _ $i { } i
	    lappend data(current_results) $i
	}
    } else {
	foreach curr [.central.s info postprocess get all_analisis] {
	    foreach i [.central.s info postprocess get results_list Contour_Fill $curr 1] {
		regsub {[(][^\)]*[)]$} $i {} i
		regsub -all _ $i { } i
		if { [lsearch $data(current_results) $i] == -1 } {
		    lappend data(current_results) $i
		}
	    }
	}
    }
    set data(current_results) [lsort -dictionary $data(current_results)]

    set tmp $data(selected_results)
    set data(selected_results) ""
    foreach i $tmp {
	if { [lsearch $data(current_results) $i] != -1 } {
	    lappend data(selected_results) $i
	}
    }
}

proc RamReports::CreatePost { {w .gid.reports } } {
    variable images
    variable data

    CreateImages
    Init

    if { [info procs ::InitWindow] != "" } {
	InitWindow $w "Reports" PostRamReportsWindowGeom "" "" 1

    } else {
	catch { destroy $w }
	toplevel $w
	wm title $w "Reports"
    }

    g_TitleFrame $w.f1 -text "report results" -grid 0
    set f1 [$w.f1 getframe]

    set data(what_loadcase) current
#     g_frame $f1.lc -grid "0 3 w"
#     g_radiobutton $f1.lc.rb1 -text "Current loadcase" -variable RamReports::data(what_loadcase) \
#         -value current -grid "0 w"
#     g_radiobutton $f1.lc.rb2 -text "All loadcases" -variable RamReports::data(what_loadcase) \
#         -value all -grid "1 w"

#     trace var RamReports::data(what_loadcase) w "RamReports::FillListBoxes ;#"
#     bind $f1.lc.rb2 <Destroy> [list trace vdelete RamReports::data(what_loadcase) w \
#                                    "RamReports::FillListBoxes ;#"]

    set sw1 [g_ScrolledWindow $f1.lf -relief sunken -borderwidth 0 -grid 0]
    set listbox1 [listbox $sw1.listbox -background white -selectmode extended \
		      -listvar RamReports::data(current_results)]
    $sw1 setwidget $listbox1

    g_frame $f1.buts -grid 1


    set sw2 [g_ScrolledWindow $f1.lf2 -relief sunken -borderwidth 0 -grid 2]
    set listbox2 [listbox $sw2.listbox -background white -selectmode extended \
		      -listvar RamReports::data(selected_results)]
    $sw2 setwidget $listbox2

    g_button $f1.buts.b1 -image $images(fletxa_d) -bd 1 -command \
	"RamReports::ListboxMoveDel $listbox1 $listbox2 move" -grid "0 px3 py3"
    g_button $f1.buts.b2 -image $images(cross) -bd 1  -command \
	"RamReports::ListboxMoveDel $listbox1 $listbox2 delete" -grid "0 px3 py3"
    

    supergrid::go $f1

    g_TitleFrame $w.f12 -text "vector results" -grid "0 new"
    set f12 [$w.f12 getframe]
    
    g_checkbutton $f12.cb1 -text X -variable RamReports::data(XComp) -grid "0 W"
    g_checkbutton $f12.cb2 -text Y -variable RamReports::data(YComp) -grid "1 W"
    g_checkbutton $f12.cb3 -text Z -variable RamReports::data(ZComp) -grid "2 W"
    g_checkbutton $f12.cb4 -text |V| -variable RamReports::data(MComp) -grid "3 W"

    supergrid::go $f12

    g_TitleFrame $w.f14 -text "tensor results" -grid "0 new"
    set f14 [$w.f14 getframe]
    
    g_checkbutton $f14.cb1 -text xx -variable RamReports::data(Mat0Comp) -grid "0 W"
    g_checkbutton $f14.cb2 -text yy -variable RamReports::data(Mat1Comp) -grid "1 W"
    g_checkbutton $f14.cb3 -text zz -variable RamReports::data(Mat2Comp) -grid "2 W"
    g_checkbutton $f14.cb4 -text xy -variable RamReports::data(Mat3Comp) -grid "3 W"
    g_checkbutton $f14.cb5 -text xz -variable RamReports::data(Mat4Comp) -grid "4 W"
    g_checkbutton $f14.cb6 -text yz -variable RamReports::data(Mat5Comp) -grid "5 W"
    g_checkbutton $f14.cb7 -text 11 -variable RamReports::data(Mat6Comp) -grid "0 W"
    g_checkbutton $f14.cb8 -text 22 -variable RamReports::data(Mat7Comp) -grid "1 W"
    g_checkbutton $f14.cb9 -text 33 -variable RamReports::data(Mat8Comp) -grid "2 W"


    supergrid::go $f14

    g_TitleFrame $w.f16 -text "gauss points" -grid "0 new"
    set f16 [$w.f16 getframe]
    
    g_radiobutton $f16.cb1 -text All -variable RamReports::data(gauss) \
	-value all -grid "0 W"
    g_radiobutton $f16.cb2 -text "Maximum" -variable \
	RamReports::data(gauss) -value absmax -grid "1 W"
    g_radiobutton $f16.cb3 -text "Maximum & Minimum"  -variable RamReports::data(gauss) \
	-value maxs -grid "2 W"

    supergrid::go $f16

    g_TitleFrame $w.f2 -text "included entities" -grid "0 new"
    set f2 [$w.f2 getframe]

    g_frame $f2.but -grid 0
    set ic 0
    foreach i "point element" {
	switch $i {
	    point { set value Nodes }
	    element { set value Elements }
	}
	g_radiobutton $f2.but.cb$i -image $images($i) -indicatoron 0 -variable \
	    RamReports::data(enposttype) -value $value -grid "$ic px2 w"
	incr ic
    }
    g_radiobutton $f2.rb1 -text "All entities" -variable RamReports::data(entities) -value all \
	-grid 0
    g_radiobutton $f2.rb2 -text "Selected entities" -variable RamReports::data(entities) -value sel \
	-grid 1

    g_checkbutton $f2.cb1 -text "Only entities with data" -variable RamReports::data(onlywithdata)\
	-grid "0 2 w" 

    supergrid::go $f2

    g_frame $w.buts -bg [CCColorActivo [$f2 cget -bg]] -grid "0 ew"

    g_button $w.buts.b1 -text OK -und 0 -width 8 -grid "0 px3 e" \
	-command "set RamReports::data(action) ok"
    g_button $w.buts.b2 -text Cancel -und 0 -width 8 -grid "1 px3 py3 w" -command \
	"set RamReports::data(action) cancel"

    supergrid::go $w
    grid columnconf $w.buts "0 1" -weight 1
    grid columnconf $w.buts "2" -weight 0

    bind $w <Escape> "tkButtonInvoke $w.buts.b2"
    bind $w.buts.b2 <Return> "tkButtonInvoke $w.buts.b2"
    bind $w <Return> "tkButtonInvoke $w.buts.b1"
    bind $w <Alt-o> "tkButtonInvoke $w.buts.b1"
    bind $w <Alt-c> "tkButtonInvoke $w.buts.b2"
    focus $w.buts.b1
    wm protocol $w WM_DELETE_WINDOW "tkButtonInvoke $w.buts.b2"

    if { [catch {FillListBoxes}] } {
	WarnWin "There are no results"
	destroy $w
	return
    }

    while 1 {
	vwait RamReports::data(action)
	
	if { $RamReports::data(action) == "cancel" } {
	    destroy $w
	    return
	}
	if { $RamReports::data(entities) == "sel" } {
	    .central.s process SelectEntities $data(enposttype)
	    set comm "RamReports::ReportPost ;#"
	    trace var ::GidPriv(selection) w $comm
	    FinishButton $w $w.buts \
	    [_ Press 'Finish' when selection\nis finished] \
	    "" disableall
	} else {
	    RamReports::ReportPost
	}
    }
}


proc RamReports::CreateImages {} {
    variable images

    if { [info exists images(point)] } { return }

    set images(point) [image create photo -data {
	R0lGODlhEAAQAKEAAAAA/////39/f////yH5BAEKAAMALAAAAAAQABAAAAIb
	nI+py+0PYwQUghCquxmITVEf6I2OgErqyioFADs=
    }]
    set images(line) [image create photo -data {
	R0lGODlhEAAQAKEAAAAAAAAA+P///////yH5BAEKAAIALAAAAAAQABAAAAId
	lI9pAOrC3gvS0ZouPnqLvoGYWJGSOXlH5LGqUAAAOw==
    }]
    set images(surface) [image create photo -data {
	R0lGODlhEAAQAKEAAAAAAAAA+PgA+P///yH5BAEKAAMALAAAAAAQABAAAAIz
	nI+pFu0AkhNDWAFPqFSJPUDdMoBQMCaflGokiMAespLlUb+xXVLWbUM1MqST
	gbhA8mwFADs=
    }]
    set images(volume) [image create photo -data {
	R0lGODlhEAAQAIAAAFBQ+P///yH5BAEKAAEALAAAAAAQABAAAAIsjG8AyOrx
	kGIwyXrTwtO9vVmYGHJZCZ7qkbIiKUWw55IhuqAvW0IdTdEEAwUAOw==
    }]
    set images(element) [image create photo -data {
	R0lGODlhEAAQAOMAAAAAAK+vr0usgVOwh0+mb06nc02pd1iyilOrek2peFmy
	ilOwhlGqeUyqfFWoc////yH5BAEKAA8ALAAAAAAQABAAAAQ68MlJqwQg6M3x
	BUIoioP3BMQ4FtqEqqHRuql6zLSK4LmY8D2BAthbEHOMI62hdDmaE0zAQjVR
	r9hJBAA7
    }]

    set images(fletxa_d) [image create photo -data {
	R0lGODlhJwAeAJECAE5qmoWh0f///wAAACH5BAEAAAIALAAAAAAnAB4AAAJa
	lI+py+0Po5y0WhfuDVlT3nkRGIoYaT4klzYr677yPMf0fTP4Ti/8/1IAh6AE
	cQgAII6/pJGJcz6hM6kiic1qtwCZtWV4fcGC1ZhMOqM56nUb/SYLlPK63VAA
	ADs=
    }]
    set images(cross) [image create photo -data {
	R0lGODlhJwAeAOMAAE5qmoWh0X6aymyIuFp2pnyYyHiUxFRwoGB8rHKOvmaC
	smmFtf///////////////yH5BAEAAA8ALAAAAAAnAB4AAASc8MlJq7046801
	+GAGht0TnKcwVug5fOXUBi8styoQUzNBmi2fbieZ5WCzGpHXqgEKONvyhvIR
	etIpEGUAGJpZ7fb0RQkOQzFzdkKE1exT4q0ep9B1zEzxyxdnXXRwbG6CU3EB
	Z31iiHKLWj0zhWmQLXwLOGiGHIBIYJsbWEOilDFJUkYrO6mlp6AWorBBjxmu
	F6yvdgGhM36+vxoRADs=
    }]
}

proc RamReports::ReportPre {} {
    variable data

    .central.s waitstate 1

    if { $data(entities) == "sel" } {
	foreach elm [trace vinfo ::GidPriv(selection)] {
	    eval trace vdelete ::GidPriv(selection) $elm
	}
	set sel [string trim $::GidPriv(selection) \"]
	set type [lindex $sel 0]
	set sel [lrange $sel 1 end]
    } else {
	set type $data(entype)
	foreach [list - num] [regexp -inline -all {Num:\s(\d+)} [.central.s info list_entities \
		                                                     $data(entype) 1:]] {
	    lappend sel $num
	}
    }

    if { [llength $sel] == 0 } {
	WarnWin "There are no entities for the report"
	.central.s waitstate 0
	return
    }

    switch $type Points { set ov ovpnt } Lines { set ov ovline } Surfaces { set ov ovsurf } \
	Volumes { set ov ovvol }
    set books ""
    if { $RamReports::data(Constraints) } { lappend books Constraints }
    if { $RamReports::data(Connections) } { lappend books Connections }
    if { $RamReports::data(Properties) } { lappend books {General properties} {Concrete properties} \
		                               {Steel properties} }
    
    foreach cnd [.central.s info Conditions $ov] {
	set book [.central.s info Conditions $cnd BOOK]
	lappend conds($book) $cnd
    }
    
    set usedconds ""
    set entities ""
    foreach i $sel {
	if { [scan $i %d:%d ini end] == 1 } { set end $ini }
	for { set j $ini } { $j <= $end } { incr j } {
	    set elm $j
	    foreach book $books {
		if { ![info exists conds($book)] } { continue }
		foreach cnd $conds($book) {
		    set vals [lindex [.central.s info Conditions $cnd geometry $j] 0]
		    if { $vals == "0 -" } { continue }
		    lappend elm $cnd [lrange $vals 3 end]
		    if { [lsearch $usedconds $cnd] == -1 } { lappend usedconds $cnd }
		}
	    }
	    lappend entities $elm
	}
    }
    if { $RamReports::data(Loads) && [info exists conds(Loads)] } {
	set currentintv [expr $::ProblemTypePriv(currentloadcase)+1]
	if { $RamReports::data(what_loadcase) == "all" } {
	    set iniinterval 2
	    foreach "- enditerval" [.central.s info intvdata num] break
	} else {
	    set iniinterval $currentintv
	    set enditerval $currentintv
	}
	for { set intv $iniinterval } { $intv <= $enditerval } { incr intv } {
	    set ic 0
	    foreach i $sel {
		if { [scan $i %d:%d ini end] == 1 } { set end $ini }
		for { set j $ini } { $j <= $end } { incr j } {
		    set elm [lindex $entities $ic]
		    foreach cnd $conds(Loads) {
		        set vals [lindex [.central.s info Conditions -interval $intv \
		                              $cnd geometry $j] 0]
		        if { $vals == "0 -" } { continue }
		        if { $RamReports::data(what_loadcase) == "all" } {
		            set LC [lindex [.central.s info intvdata -interval $intv] 2]
		            set t "LC <b>$LC</b> [lrange $vals 3 end]"
		            lappend elm $cnd $t
		        } else {
		            lappend elm $cnd [lrange $vals 3 end]
		        }
		        if { [lsearch $usedconds $cnd] == -1 } { lappend usedconds $cnd }
		    }
		    set entities [lreplace $entities $ic $ic $elm]
		    incr ic
		}
	    }
	}
    }
    .central.s waitstate 0

    set dir [ConcretePrefs::GiveTempDir]
    if { $dir == "" } { 
	WarnWin "Could not find temporal directory. Save project to continue"
	return
    }
    if { [catch {
	set reportname [file join $dir tmp_report.html]
	set fout [open $reportname w]
    }]} {
	WarnWin "error: failed to write to file '[file join $dir tmp_concrete.dat]'"
	return
    }
    set title "Geometrical entities report"
    puts $fout "<html>\n<head>\n<title>$title</title>\n</head>\n<body bgcolor=\"#FFFFFF\">"
    puts $fout "<h1>$title</h1>"

    puts $fout "<table border=1><tr><td>Number</td>"
    foreach i $usedconds {
	puts $fout "<td>$i</td>"
    }
    puts $fout </tr>

    foreach elm $entities {
	if { $RamReports::data(onlywithdata) && [llength $elm] == 1 } { continue }
	puts $fout "<tr><td>[lindex $elm 0]</td>"
	foreach cnd $usedconds {
	    set ipos [lsearch $elm $cnd]
	    if { $ipos == -1 } {
		puts $fout <td></td>
	    } else {
		incr ipos
		puts $fout <td>[lindex $elm $ipos]</td>
	    }
	}
	puts $fout </tr>
    }
    puts $fout "</table>"
    puts $fout "</body>\n</html>"
    close $fout

    set top [winfo toplevel .gid]
    set x [expr [winfo x $top]+[winfo width $top]/2-350]
    set y [expr [winfo y $top]+[winfo height $top]/2-300]
    set geom 650x600+${x}+$y
    HelpWindowRam -geomhelp $geom -tt -title Report -win .gid.report $reportname
}

proc RamReports::NicePrintFloat { val } {

    set val [format "%.4g" $val]
    if { [regexp {(?i)^(.*)e(\+|-|)([0-9]{3})$} $val {} before sign exp] } {
	if { [string match 0* $exp] } {
	    set exp [string range $exp 1 end]
	}
	set val ${before}e$sign$exp
    }
    return $val
}

proc RamReports::ReportPost {} {
    variable data

    .central.s waitstate 1

    if { $data(entities) == "sel" } {
	foreach elm [trace vinfo ::GidPriv(selection)] {
	    eval trace vdelete ::GidPriv(selection) $elm
	}
	set sel [string trim $::GidPriv(selection) \"]
	set type [lindex $sel 0]
	set sel [lrange $sel 1 end]
	if { [llength $sel] == 0 } {
	    WarnWin "There are no entities for the report"
	    .central.s waitstate 0
	    return
	}
    } else {
	set sel 1:
	set type $data(enposttype)
    }

    set dir [ConcretePrefs::GiveTempDir]
    if { $dir == "" } { 
	.central.s waitstate 0
	WarnWin "Could not find temporal directory. Save project to continue"
	return
    }
    if { [catch {
	set reportname [file join $dir tmp_report.html]
	set fout [open $reportname w]
    }]} {
	.central.s waitstate 0
	WarnWin "error: failed to write to file '[file join $dir tmp_concrete.dat]'"
	return
    }
    set curr [.central.s info postprocess get cur_analisis]

    set title "Mesh entities report"
    puts $fout "<html>\n<head>\n<title>$title</title>\n</head>\n<body bgcolor=\"#FFFFFF\">"
    puts $fout "<h1>$title</h1>"
    puts $fout "<h2>Result: $curr</h2>"
    puts $fout "<table border=1><tr><td>Number</td>"

    set list_ent [eval .central.s info list_entities $type $sel]
    set length [llength $list_ent]

    foreach i $data(selected_results) {
	puts $fout "<td>$i</td>"
    }
    puts $fout </tr>
    set i 1
    while { $i < $length } {
	incr i
	set num [lindex $list_ent $i]
	while { [lindex $list_ent $i] != "results:" && $i < $length } {
	    incr i
	}
	incr i
	set res [lindex $list_ent $i]
	set NumPrintedResults 0
	set linetoprint "<tr><td>$num</td>"
	foreach j $data(selected_results) {
	    set found 0
	    foreach k $res {
		regsub {[(][^\)]*[)]$} [lindex $k 0] {} name
		if { $name == $j } {
		    set val [lindex $k end]
		    set found 1
		    break
		}
	    }
	    if { !$found } {
		append linetoprint <td></td>
	    } else {
		set n [llength [lindex $val 0]]
		if { $data(gauss) == "absmax" } {
		    for { set icomp 0 } { $icomp < $n } { incr icomp } {
		        set maxs($icomp) 0.0
		    }
		    foreach igauss $val {
		        for { set icomp 0 } { $icomp < $n } { incr icomp } {
		            if { abs([lindex $igauss $icomp]) > abs($maxs($icomp)) } {
		                set maxs($icomp) [lindex $igauss $icomp]
		            }
		        }
		    }
		    set vali ""
		    for { set icomp 0 } { $icomp < $n } { incr icomp } {
		        lappend vali $maxs($icomp)
		    }
		    set val [list $vali]
		} elseif { $data(gauss) == "maxs" } {
		    for { set icomp 0 } { $icomp < $n } { incr icomp } {
		        set max($icomp) -1e90
		        set min($icomp) 1e90
		    }
		    foreach igauss $val {
		        for { set icomp 0 } { $icomp < $n } { incr icomp } {
		            if { [lindex $igauss $icomp] > $max($icomp) } {
		                set max($icomp) [lindex $igauss $icomp]
		            }
		            if { [lindex $igauss $icomp] < $min($icomp) } {
		                set min($icomp) [lindex $igauss $icomp]
		            }
		        }
		    }
		    set val ""
		    set vali ""
		    for { set icomp 0 } { $icomp < $n } { incr icomp } {
		        lappend vali $max($icomp)
		    }
		    lappend val $vali
		    set vali ""
		    for { set icomp 0 } { $icomp < $n } { incr icomp } {
		        lappend vali $min($icomp)
		    }
		    lappend val $vali
		}
		append linetoprint <td>
		set isfirst 1
		foreach ival $val {
		    if { $isfirst } {
		        set isfirst 0
		    } else { append linetoprint " <br>" }
		    set fval ""
		    switch [llength $ival] {
		        1 { 
		            set err [catch { lappend fval [NicePrintFloat $val] }]
		            if { !$err } { incr NumPrintedResults }
		        }
		        3 - 4 { 
		            set ic 0
		            foreach rr "X Y Z" {
		                if { $data(${rr}Comp) } {
		                    set err [catch { lappend fval [NicePrintFloat [lindex $ival $ic]]}]
		                    if { !$err } { incr NumPrintedResults }
		                }
		                incr ic
		            }
		            if { $data(MComp) } {
		                if { [llength $ival] == 3 } {
		                    set err [catch {
		                        set val [expr sqrt([lindex $ival 0]*[lindex $ival 0]+\
		                            [lindex $ival 1]*[lindex $ival 1]+\
		                            [lindex $ival 2]*[lindex $ival 2])]
		                        lappend fval [NicePrintFloat $val]
		                    }]
		                    if { !$err } { incr NumPrintedResults }
		                } else {
		                    set err [catch { lappend fval [NicePrintFloat [lindex $ival 3]] }]
		                    if { !$err } { incr NumPrintedResults }
		                }
		            }
		        }
		        9 {
		            for { set k 0 } { $k < 9 } { incr k } {
		                if { $data(Mat${k}Comp) } {
		                    set err [catch { lappend fval [NicePrintFloat [lindex $ival $k]]}]
		                    if { !$err } { incr NumPrintedResults }
		                }
		            }
		        }
		    }
		    append linetoprint $fval
		}
		append linetoprint </td>
	    }
	}
	append linetoprint </tr>
	if { $NumPrintedResults || $data(onlywithdata) == 0 } {
	    puts $fout $linetoprint
	}
	incr i
    }
    puts $fout "</table>"
    puts $fout "</body>\n</html>"
    close $fout


    .central.s waitstate 0


    set top [winfo toplevel .gid]
    set x [expr [winfo x $top]+[winfo width $top]/2-350]
    set y [expr [winfo y $top]+[winfo height $top]/2-300]
    set geom 650x600+${x}+$y
    HelpWindowRam -geomhelp $geom -tt -title Report -win .gid.report $reportname


}
